<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>JSEOQ Testing Script</title>

    <!-- EOQ libraries -->
    <script src="../eoq2/query/query.js"></script>
    <script src="../eoq2/command/command.js"></script>
    <script src="../eoq2/eoq2.js"></script>
    <script src="../eoq2/util/logger.js"></script>
    <script src="../eoq2/command/result.js"></script>
    <script src="../eoq2/frame/frame.js"></script>
    <script src="../eoq2/event/event.js"></script>
    <script src="../eoq2/domain/domain.js"></script>
    <script src="../eoq2/serialization/serializer.js"></script>
    <script src="../eoq2/serialization/jsonserializer.js"></script>
    <script src="../eoq2/serialization/textserializer.js"></script>
    <script src="../eoq2/domain/remote/websocketdomain.js"></script>

    <!-- External library to render JSON in HTML -->
    <script src="js/renderjson.js"></script>

    <script src="contrib/jquery/jquery-3.3.1.min.js"></script>

    <!-- Testing Functions -->
    <script src="js/testing.js"></script>

    <link rel="stylesheet" type="text/css" href="css/jseoqdemo.css" />
</head>

<body onload="Start()">
    <h1 style="text-align: center;">JSEOQ Commands & Queries</h1>

    <div id="console" class="">
        <!-- all output goes here -->
    </div>

    <script>
        async function Start() {
            /*
            *   Template Code
            * */
            CreateStatusBlock();

            /*
            *   Test Related Code
            * */

            // settings
            let webSocketUrl = 'ws://localhost:8000/ws/eoq.do';
            let modelfile = "MinimalFlightControl.oaam";

            // initialize the domain
            UpdateStatusBlockOnlyText("Connecting to websocket...<br>", append = false);
            let domain = new eoq2.domain.remote.WebSocketDomain(webSocketUrl, logger = new eoq2.util.NoLogging());
            try {
                await domain.Open();
            }catch{
                UpdateStatusBlockOnlyText("No websocket available...<br>", append = false);
                SetStatusFailed();
            }

            // get domain root
            UpdateStatusBlockOnlyText("Getting root...<br>", append = true);
            root = await GetRoot(domain, modelfile);

            // initialize a new session
            UpdateStatusBlockOnlyText("Opening session...", append = true);
            let sessionId = await domain.Do(CMD.Hel('user', 'pw'));
            UpdateStatusBlockOnlyText("Obtained Session ID "+sessionId+" ...<br>", append = true);

            // define cmds
            let cmds = [
                // observe all events
                CMD.Cmp().Ses(sessionId) //session id must be known in order to observe events
                    .Obs('CHG','*'), //all change events
                //any
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('FLATTEN').Any(QRY.Obj(0))),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Any(QRY.Arr([QRY.Obj(14),QRY.Obj(21)]))),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Any(QRY.Arr([QRY.Obj(14),QRY.Obj(21)])).Not()),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Sel(  QRY.Pth('tasks').Any(QRY.Obj(14))  )),
                CMD.Get(QRY.Arr([QRY.Obj(0)]).Sel(QRY.Any(QRY.Arr([QRY.Obj(0)])))),
                CMD.Get(QRY.Qry().Cls('Task').Sel(QRY.Any(QRY.Obj(0).Cls('Task')))),

                // all
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').All(QRY.Arr([QRY.Obj(14),QRY.Obj(17)]))),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').All(QRY.Arr([QRY.Obj(14),QRY.Obj(17)])).Not()),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions')),

                // test instance of
                CMD.Get(QRY.Qry(root).Ino('EObject')),
                // test add
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Add(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0),'tasks',QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks').Arr([QRY.Idx(0),QRY.Idx(1)])),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Add(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0),'tasks',QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks').Arr([QRY.Idx(0),QRY.Idx(1)])),

                //test querify
                CMD.Qrf(QRY.Qry(root).Cls('Task').Idx(20)),
                CMD.Cmp().Get(QRY.Qry(root).Cls('Task').Idx([1,15,2]))
                    .Qrf(QRY.His(0)) //convert the result to a query
                    .Get(QRY.His(1)), //should show the same result as command 1 

                // observe no events
                CMD.Cmp().Ses(sessionId).Ubs('CHG','*'),

                // test remove
                CMD.Cmp().Crn('http://www.oaam.de/oaam/model/v140/functions','Task',1)
                    .Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0))
                    .Add(QRY.His(1),'tasks',QRY.His(0)) //add the new task
                    .Rem(QRY.His(1),'tasks',QRY.His(0)), //remove it again
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks')),
                // test mov
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Mov(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks').Idx(0),5),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Mov(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks').Idx(5),0),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                // test clone
                CMD.Clo(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions'),CMD.CloModes.CLS),
                CMD.Clo(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions'),CMD.CloModes.ATT),
                CMD.Clo(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions'),CMD.CloModes.DEP),
                CMD.Clo(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions'),CMD.CloModes.FUL),
                // test create
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Equ('OUT')),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1'))),
                CMD.Crt(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1')).Idx(0).Met('CLASS'),5),
                // test create by name
                CMD.Crn('http://www.oaam.de/oaam/model/v140/functions','Task',6),
                CMD.Crn('http://www.oaam.de/oaam/model/v140/functions','Task',1,[]),
                CMD.Crn('http://www.oaam.de/oaam/model/v140/functions','Task',1,['myClass']),
                CMD.Crn('http://www.eclipse.org/emf/2002/Ecore','EClass',1,['myClass']),
                CMD.Crn('http://www.eclipse.org/emf/2002/Ecore','EClass',1,['myClass',null]),   
                // test set
                CMD.Cmp().Crn('http://www.oaam.de/oaam/model/v140/functions','Task',1)
                    .Crn('http://www.oaam.de/oaam/model/v140/library','TaskType',1)
                    .Set(QRY.His(0),['name','type'],QRY.Arr(['New Task',QRY.His(1)])),
                // test rollback
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Cmp().Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0))
                    .Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks'))
                    .Add(QRY.His(0),'tasks',QRY.His(1).Arr([QRY.Idx(3),QRY.Idx(1)]))
                    .Rem(QRY.His(0),'tasks',QRY.His(0).Pth('tasks'))
                    .Add(QRY.His(0).Pth('tasks'),'tasks',QRY.His(1).Arr([QRY.Idx(0),QRY.Idx(1)])),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('tasks')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks')),
                // test set
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1'))),
                CMD.Set(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1')),'name','ElevatorR5589'),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1'))),
                CMD.Set(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR5589')),'name','ElevatorR1'), //revert change
                // test select
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Idx(0).Pth('subfunctions').Idx(0).Pth('tasks').Idx(0).Pth('type').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Equ('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Csp(QRY.Qry(root).Cls('Signal')).Sel(QRY.Idx(1).Pth('source').Met('CONTAINER').Equ(QRY.Idx(0)))),
                //test single value selection
                CMD.Get(QRY.Qry(root).Arr(['A','B','C']).Sel(true)),
                CMD.Get(QRY.Qry(root).Arr(['A','B','C']).Sel(false)),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('tasks').Sel(true)),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('tasks').Sel(false)),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(true)),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(false)),
                // test meta
                CMD.Get(QRY.Met('METAMODELS')),
                CMD.Get(QRY.Qry(root).Met('CLASS')),
                CMD.Get(QRY.Met('CLASS',['http://www.oaam.de/oaam/model/v140/functions','Task'])), //context less
                CMD.Get(QRY.Qry(root).Met('CLASSNAME')),
                CMD.Get(QRY.Qry(root).Met('CONTAINER')),
                CMD.Get(QRY.Qry(root).Met('PARENT')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('ALLPARENTS')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('ASSOCIATES').Met('CLASSNAME')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('ASSOCIATES',[QRY.Qry(root).Pth('allocations')]).Met('CLASSNAME')),
                CMD.Get(QRY.Qry(root).Met('INDEX')),
                CMD.Get(QRY.Qry(root).Met('CONTAININGFEATURE')),
                CMD.Get(QRY.Qry(root).Met('FEATURES')),
                CMD.Get(QRY.Qry(root).Met('FEATURENAMES')),
                CMD.Get(QRY.Qry(root).Met('FEATUREVALUES')),
                CMD.Get(QRY.Qry(root).Met('ATTRIBUTES')),
                CMD.Get(QRY.Qry(root).Met('ATTRIBUTENAMES')),
                CMD.Get(QRY.Qry(root).Met('ATTRIBUTEVALUES')),
                CMD.Get(QRY.Qry(root).Met('REFERENCES')),
                CMD.Get(QRY.Qry(root).Met('REFERENCENAMES')),
                CMD.Get(QRY.Qry(root).Met('REFERENCEVALUES')),
                CMD.Get(QRY.Qry(root).Met('CONTAINMENTS')),
                CMD.Get(QRY.Qry(root).Met('CONTAINMENTNAMES')),
                CMD.Get(QRY.Qry(root).Met('CONTAINMENTVALUES')),
                CMD.Get(QRY.Qry(root).Met('IF',[QRY.Met("PARENT"),QRY.Met("PARENT").Pth("name"),"no"])),
                CMD.Get(QRY.Met('IF',[QRY.Met("PARENT"),QRY.Met("PARENT").Pth("name"),"no"])),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('FLATTEN')),
                // test class meta
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('CLASS').Met('PACKAGE').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('CLASS').Met('SUPERTYPES').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('CLASS').Met('ALLSUPERTYPES').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('CLASS').Met('IMPLEMENTERS').Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Idx(0).Met('CLASS').Met('ALLIMPLEMENTERS').Pth('name')),

                // index
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx(0)),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('FLATTEN')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('SIZE')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('SORTASC')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx('SORTDSC')),
                CMD.Get(QRY.Qry(root).Pth('functions').Pth('subfunctions').Pth('subfunctions').Pth('subfunctions').Pth('tasks').Idx([0,6,2])), //extract range

                // // test eqa
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name') ),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Eqa(['ElevatorR1','AileronL1']) ),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Sel(QRY.Eqa(['ElevatorR1','AileronL1'])) ),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Eqa(['ElevatorR1','AileronL1'])) ),

                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name') ),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Eqa(QRY.Arr(['ElevatorR1','AileronL1'])) ),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Sel(QRY.Eqa(QRY.Arr(['ElevatorR1','AileronL1']))) ),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Eqa(QRY.Arr(['ElevatorR1','AileronL1']))) ),

                // test neq
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Neq('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                // test gre
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                // test les
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Les('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                // test add
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('outputs').Met('SIZE').Add(2)),
                // test sub
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('outputs').Met('SIZE').Sub(2)),
                // test mul
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('outputs').Met('SIZE').Mul(2)),
                // test dev
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('outputs').Met('SIZE').Div(2)),
                // test csp
                CMD.Get(QRY.Qry(root).Cls('Task').Csp(QRY.Qry(root).Cls('Signal'))),
                // test its
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Les('ElevatorR1'))),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Gre('AileronR1'))),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Les('ElevatorR1')).Its(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Gre('AileronR1')))),
                // test dif
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Les('ElevatorR1')).Dif(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Gre('AileronR1')))), // TODO Dif Qry?
                // test uni
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Les('ElevatorR1')).Uni(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Gre('AileronR1')))),
                // test con
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Les('ElevatorR1')).Con(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Gre('AileronR1')))),
                // test change
                CMD.Chg(0,0), //get all changes
                CMD.Chg(0,17), //end is out of range
                CMD.Chg(0,5), //end is in range
                CMD.Chg(3,0), //start is in range
                CMD.Chg(17,0), //start is out of range
                CMD.Cmp()
                    .Mut()
                    .Chg(0,0)
                    .Umt()
                    .Get(QRY.His(-2).Sel(QRY.Idx(9).Equ(13))), //searches the change with transaction ID 13

                // logical connection of statements for select
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator')).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Mul(QRY.Pth('outputs').Met('SIZE').Equ(1).Mul(QRY.Pth('name').Les('XXXXX')))).Pth('name')),

                // empty list operations
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('XXXX'))), // --> []
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('XXXX')).Met('CLASS')),// --> []
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('XXXX')).Sel(QRY.Pth('name').Equ('YYYY')).Met('CLASS')), // --> []

                // terminate statement
                CMD.Get(QRY.Qry(root).Cls('ConnectionAssignmentSegment').Pth('location').Trm().Pth('name')), //no fail
                CMD.Get(QRY.Qry(root).Cls('ConnectionAssignmentSegment').Pth('location').Trm().Met('CLASS').Met('PACKAGE').Pth('nsURI')), //no fail
                CMD.Get(QRY.Qry(root).Cls('ConnectionAssignmentSegment').Pth('location').Trm().Met('CLASS').Met('PACKAGE').Uni([])),
                CMD.Get(QRY.Qry(root).Cls('SignalAssignmentSegment').Trm(QRY.Qry().Met('SIZE').Equ(0),2).Met('SIZE')), //custom terminate condition and return value
                CMD.Get(QRY.Qry(root).Cls('SignalAssignmentSegment').Trm(QRY.Qry().Met('SIZE').Equ(0),2).Met('SIZE').Add(3)),
                CMD.Get(QRY.Qry(root).Cls('ConnectionAssignmentSegment').Trm(QRY.Qry().Met('SIZE').Equ(0),2).Met('SIZE')), //custom terminate condition and return value
                CMD.Get(QRY.Qry(root).Cls('ConnectionAssignmentSegment').Trm(QRY.Qry().Met('SIZE').Equ(0),2).Met('SIZE').Add(3)),

                // zip operation
                CMD.Get(QRY.Arr([1,2,3]).Zip([QRY.Arr([1,2,3]),QRY.Arr([1,2,3])])),
                CMD.Get(QRY.Qry(root).Cls('Task').Zip([QRY.Pth('name'),QRY.Pth('type'),QRY.Pth('type').Pth('name')])),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('outputs').Met('SIZE').Gre(2)).Zip([QRY.Pth('outputs'),QRY.Pth('outputs').Pth('name')])),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('outputs').Met('SIZE').Gre(2)).Zip([QRY.Pth('outputs').Pth('name'),QRY.Pth('outputs')])),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('outputs').Met('SIZE').Gre(2)).Zip([QRY.Pth('outputs').Zip([QRY.Pth('name')]),QRY.Pth('outputs').Pth('name')])), 

                // boolean operations
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Orr(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Xor(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').And(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('type').Pth('name').Gre('Elevator').Nad(QRY.Pth('outputs').Met('SIZE').Equ(1))).Pth('name')),

                // test EEnum reading and setting
                CMD.Get(QRY.Qry(root).Pth('library').Cls('IoType')),
                CMD.Get(QRY.Qry(root).Pth('library').Cls('IoType').Pth('direction')),
                CMD.Set(QRY.Qry(root).Pth('library').Cls('IoType').Idx(0),'direction','NONE'),
                CMD.Set(QRY.Qry(root).Pth('library').Cls('IoType').Idx(0),'direction','IN'),
                CMD.Get(QRY.Qry(root).Pth('library').Cls('IoType').Idx(0).Met('CLASS').Pth('eAttributes').Sel(QRY.Pth('name').Equ('direction')).Idx(0).Pth('eType').Pth('eLiterals')),
                     
                // test regex
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Rgx('Elevator.1')),
                CMD.Get(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Rgx('Elevator.1'))),
                CMD.Get(QRY.Qry(root).Cls('Task').Pth('name').Sel(QRY.Rgx('Elevator.1'))),
                   
                // test try
                CMD.Get(QRY.Qry(root).Pth('functions').Cls('Task').Try(QRY.Pth('name'),'?')),
                CMD.Get(QRY.Qry(root).Pth('functions').Cls('Task').Pth('outputs')),
                CMD.Get(QRY.Qry(root).Pth('functions').Cls('Task').Pth('outputs').Pth('declaration')),
                CMD.Get(QRY.Try(QRY.Qry(root).Pth('functions').Cls('Task').Pth('outputs').Pth('declaration').Pth('name'),'?')),
                CMD.Get(QRY.Qry(root).Pth('functions').Cls('Task').Try(QRY.Pth('outputs').Pth('declaration').Pth('name').Trm(null,'empty'),'?')),
                CMD.Get(QRY.Qry(root).Pth('functions').Cls('Task').Pth('outputs').Try(QRY.Pth('declaration').Pth('name').Trm(null,'empty'),'?')),
                   
                // test compare
                // CMD.Cpr(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1')).Idx(0),QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorL1')).Idx(0),'STD'), //name, id and name of inputs should be different
                // CMD.Cpr(QRY.Qry(root).Cls('Task').Sel(QRY.Pth('name').Equ('ElevatorR1')).Idx(0),QRY.Qry(root).Cls('Signal').Idx(0),'STD'), //comparing task and signal makes no sense
                // CMD.Cpr(QRY.Qry(root).Cls('Subfunctions').Idx(0),QRY.Qry(root).Cls('Subfunctions').Idx(0),'STD'), //complex tree compare of the same element
                // CMD.Cpr(QRY.Qry(root).Cls('Subfunctions').Idx(1),QRY.Qry(root).Cls('Subfunctions').Idx(0),'STD'), //complex tree compare of different elements
                // CMD.Cpr(QRY.Qry(root).Cls('Subfunctions').Idx(0),QRY.Qry(root).Cls('Subfunctions').Idx(1),'STD'), //complex tree compare of different elements
                // CMD.Cpr(QRY.Qry(root).Cls('Subfunctions').Idx(2),QRY.Qry(root).Cls('Subfunctions').Idx(3),'STD'), //complex tree compare of different elements
                // CMD.Get(QRY.Qry(root).Cls('Subfunctions').Idx(2).Pth('name')),
                // CMD.Get(QRY.Qry(root).Cls('Subfunctions').Idx(3).Pth('name')),

                // finished
                // CMD.Gby(sessionId)
            ];

            // testing
            let failedTests = [];
            UpdateStatusBlockOnlyText("Starting testing...", append = true);
            for (let testNr in cmds) {
                // console.log(testNr);
                let cmd = cmds[testNr];
                // run cmd
                // let result = await TestCommand(domain,cmd,testNr);
                TestCommand(domain, cmd, testNr).then(function (result) {
                    // correct test
                    PrintCmdInfo(cmd, testNr);
                    PrintResult(result, testNr);
                    // update status
                    UpdateStatusBlock(testNr, cmds, failedTests);
                }).catch(function (error) {
                    // failed test
                    PrintCmdInfo(cmd, testNr);
                    PrintFailedCmd(error, testNr);
                    failedTests = PushIfUnique(failedTests, testNr);
                    // update status
                    UpdateStatusBlock(testNr, cmds, failedTests);
                });
            }
        }
    </script>
</body>

</html>